"use strict";
/**
 * Project Lavenza
 * Copyright 2017-2019 Aigachu, All Rights Reserved
 *
 * License: https://github.com/Aigachu/Lavenza-II/blob/master/LICENSE
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Composer = void 0;
// Imports.
const Service_1 = require("../../Service/Service");
const ServiceContainer_1 = require("../../Service/ServiceContainer");
const Gestalt_1 = require("../Gestalt");
/**
 * Provides an abstract class for Composers.
 *
 * Composers are directly tied to the Gestalt database service.
 *
 * They serve as bootstrappers to set any schemas or collections up during runtime.
 *
 * These services can also serve as helpers to access specific parts of the database.
 */
class Composer extends Service_1.Service {
    constructor() {
        super(...arguments);
        /**
         * Service tags.
         */
        this.tags = ["composer"];
    }
    /**
     * Build tasks for composers.
     */
    build() {
        return __awaiter(this, void 0, void 0, function* () {
            this.gestaltService = ServiceContainer_1.ServiceContainer.get(Gestalt_1.Gestalt);
        });
    }
}
exports.Composer = Composer;
