"use strict";
/**
 * Project Lavenza
 * Copyright 2017-2019 Aigachu, All Rights Reserved
 *
 * License: https://github.com/Aigachu/Lavenza-II/blob/master/LICENSE
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Resonator = void 0;
// Imports.
const Service_1 = require("../../Service/Service");
/**
 * Provides an abstract class for Resonators.
 *
 * Resonators are services that will simply act upon messages heard from a client.
 *
 * When a message is heard, a Resonance is created and sent to Resonators. This Resonance contains information about
 * the message received. Anything can be done with a message that has been heard.
 */
class Resonator extends Service_1.Service {
    constructor() {
        super(...arguments);
        /**
         * Service tags.
         */
        this.tags = ["resonator"];
    }
}
exports.Resonator = Resonator;
