"use strict";
/**
 * Project Lavenza
 * Copyright 2017-2019 Aigachu, All Rights Reserved
 *
 * License: https://github.com/Aigachu/Lavenza-II/blob/master/LICENSE
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TwitchCommandHelpHandler = void 0;
const CommandHelpHandler_1 = require("../../CommandHelpHandler/CommandHelpHandler");
/**
 * Provides an abstract class for Help Handlers.
 *
 * Help handlers are simple classes that determine what to do when the help argument is invoked for a command.
 */
class TwitchCommandHelpHandler extends CommandHelpHandler_1.CommandHelpHandler {
    /**
     * Method that handles what happens when the help argument is invoked.
     *
     * @param instruction
     *   Instruction to fire the help handler for.
     */
    help(instruction) {
        return __awaiter(this, void 0, void 0, function* () {
            yield instruction.resonance.send(instruction.resonance.author, "Sadly, command help text is currently not available for Twitch. Sorry!");
        });
    }
}
exports.TwitchCommandHelpHandler = TwitchCommandHelpHandler;
