"use strict";
/**
 * Project Lavenza
 * Copyright 2017-2019 Aigachu, All Rights Reserved
 *
 * License: https://github.com/Aigachu/Lavenza-II/blob/master/LICENSE
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Listener = void 0;
/**
 * Provides an abstract base class for Listeners.
 *
 * Listeners receive a 'Resonance' from a Bot and can act upon what they hear.
 *
 * They are basically entry points for extended functionality when wanting to tell a Bot what to do upon hearing
 * a message from any given client.
 */
class Listener {
    /**
     * Perform build tasks.
     *
     * Since Listeners will sometimes need to build data asynchronously,they can call this function once to set
     * their properties and more.
     */
    build() {
        return __awaiter(this, void 0, void 0, function* () {
            // The base build() function for listeners doesn't do anything. Additional assignments may be done in this function.
        });
    }
}
exports.Listener = Listener;
